import Vue from 'vue';
import Component from 'vue-class-component';
import { Prop, Inject } from 'vue-property-decorator';
import cuid from 'cuid';
import axios from 'axios';

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return extendStatics(d, b);
};

function __extends(d, b) {
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __decorate(decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
}

function __awaiter(thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

var default_1 = /** @class */ (function () {
    function default_1(mm) {
        this.mm = mm;
    }
    default_1.prototype.set = function (pm) {
        var _this = this;
        this.clear();
        return new Promise(function (fn) {
            _this.fn = fn;
            _this.id = window.setTimeout(function () { return fn(pm()); }, _this.mm);
        });
    };
    default_1.prototype.clear = function () {
        window.clearTimeout(this.id);
        if (this.fn) {
            this.fn();
        }
    };
    return default_1;
}());

var Mutator = /** @class */ (function () {
    function Mutator(key, value) {
        this.key = key;
        this.value = value;
    }
    Mutator.prototype.mutate = function (inputs) {
        var key = Array.from(this.key);
        var tip = key.pop();
        key.reduce(function (i, k) { return i[k]; }, inputs)[tip] = this.value;
        return inputs;
    };
    return Mutator;
}());

var Builder = /** @class */ (function () {
    function Builder() {
        this.container = new FormData();
    }
    Builder.prototype.build = function (input, root) {
        if (root === void 0) { root = ''; }
        if (input instanceof Blob)
            this.container.append(root, input);
        else if (input instanceof Date)
            this.container.append(root, input.toISOString());
        else if (typeof input == 'string')
            this.container.append(root, input);
        else if (typeof input == 'number')
            this.container.append(root, "" + input);
        else if (typeof input == 'boolean')
            this.container.append(root, "" + (input ? 1 : 0));
        else if (typeof input == 'object')
            for (var name in input)
                this.build(input[name], root ? root + "[" + name + "]" : name);
        return this.container;
    };
    return Builder;
}());

var _this = undefined;
var state = function (inputs, errors) {
    if (errors === void 0) { errors = {}; }
    return ({
        inputs: inputs,
        errors: errors,
        validation: null,
        submission: null,
        validating: false,
        submitting: false
    });
};
var mutations = {
    inputs: function (state, mutator) { return state.inputs = Object.assign({}, mutator.mutate(state.inputs)); },
    errors: function (state, errors) { return state.errors = Object.assign({}, errors); },
    replace: function (state, inputs) { return state.inputs = Object.assign({}, inputs); },
    validation: function (state, validation) { return state.validation = validation; },
    submission: function (state, submission) { return state.submission = submission; },
    validating: function (state, pending) { return state.validating = pending; },
    submitting: function (state, pending) { return state.submitting = pending; }
};
var actions = {
    validation: function (_a, config) {
        var state = _a.state, commit = _a.commit;
        return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_b) {
                if (state.validation) {
                    commit('validating', true);
                    config.data = state.inputs;
                    return [2 /*return*/, axios(state.validation, config).then((function (response) {
                            commit('validating', false);
                            commit('errors', response.data.errors || {});
                            return response;
                        }))];
                }
                return [2 /*return*/];
            });
        });
    },
    submission: function (_a, config) {
        var state = _a.state, commit = _a.commit;
        return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_b) {
                if (state.submission) {
                    commit('submitting', true);
                    config.data = new Builder().build(state.inputs);
                    return [2 /*return*/, axios(state.submission, config).then(function (response) {
                            commit('submitting', false);
                            commit('errors', response.data.errors || {});
                            return response;
                        })];
                }
                return [2 /*return*/];
            });
        });
    }
};

var default_1$1 = /** @class */ (function () {
    function default_1(store, config) {
        this.id = cuid();
        this.store = store;
        this.config = config || {
            validation: {
                method: 'POST'
            },
            submission: {
                method: 'POST',
                validateStatus: function (code) { return code < 400 || code == 422; }
            }
        };
    }
    Object.defineProperty(default_1.prototype, "state", {
        get: function () {
            return this.store.state[this.id];
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(default_1.prototype, "inputs", {
        get: function () {
            return this.state.inputs;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(default_1.prototype, "errors", {
        get: function () {
            return this.state.errors;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(default_1.prototype, "validating", {
        get: function () {
            return this.state.validating;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(default_1.prototype, "submitting", {
        get: function () {
            return this.state.submitting;
        },
        enumerable: true,
        configurable: true
    });
    default_1.prototype.commit = function (type, config) {
        this.store.commit(this.id + "/" + type, config);
    };
    default_1.prototype.dispatch = function (type, config) {
        if (config === void 0) { config = {}; }
        return this.store.dispatch(this.id + "/" + type, __assign({}, this.config[type], config));
    };
    default_1.prototype.register = function (state$1, options) {
        this.store.registerModule(this.id, {
            namespaced: true,
            state: state(state$1),
            mutations: mutations,
            actions: actions
        }, options);
    };
    default_1.prototype.unregister = function () {
        if (this.store.state[this.id]) {
            this.store.unregisterModule(this.id);
        }
    };
    return default_1;
}());

var default_1$2 = /** @class */ (function (_super) {
    __extends(default_1$1, _super);
    function default_1$1() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.delayer = new default_1(120);
        return _this;
    }
    Object.defineProperty(default_1$1.prototype, "value", {
        get: function () {
            return this.keys.reduce(function (i, k) {
                return i[k];
            }, this.editor.inputs);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(default_1$1.prototype, "errors", {
        get: function () {
            return this.editor.errors[this.keys.join('.')] || [];
        },
        enumerable: true,
        configurable: true
    });
    default_1$1.prototype.input = function (e) {
        var _this = this;
        this.$emit('input', e);
        this.editor.commit('inputs', new Mutator(this.keys, e instanceof Event
            ? e.target.value
            : e));
        return this.delayer.set(function () { return _this.editor.dispatch('validation'); });
    };
    __decorate([
        Prop()
    ], default_1$1.prototype, "keys", void 0);
    __decorate([
        Inject()
    ], default_1$1.prototype, "editor", void 0);
    default_1$1 = __decorate([
        Component({ name: 'Editor' })
    ], default_1$1);
    return default_1$1;
}(Vue));

export default default_1$2;
export { default_1$1 as Editor, Mutator };
