import { AxiosRequestConfig as Config } from 'axios';
import { DefineMutations, DefineActions } from 'vuex-type-helper';
import Mutator from './utils/Mutator';
export interface E {
    [key: string]: string[];
}
export interface S<T> {
    inputs: T;
    errors: E;
    validation: null | string;
    submission: null | string;
    validating: boolean;
    submitting: boolean;
}
export interface M<T> {
    inputs: Mutator<any, T>;
    errors: E;
    replace: T;
    validation: string;
    submission: string;
    validating: boolean;
    submitting: boolean;
}
export interface A {
    validation: Config;
    submission: Config;
}
export declare const state: <T>(inputs: T, errors?: {}) => S<T>;
export declare const mutations: DefineMutations<M<any>, S<any>>;
export declare const actions: DefineActions<A, S<any>, M<any>>;
