import { AxiosResponse as Response, AxiosRequestConfig as Config } from 'axios';
import { Store, ModuleOptions } from 'vuex';
import { A, S, M, E } from '../store';
declare type C = {
    [K in keyof A]: Config;
};
export default class<T = any> {
    id: string;
    store: Store<any>;
    config: C;
    constructor(store: Store<any>, config?: C);
    readonly state: S<T>;
    readonly inputs: T;
    readonly errors: E;
    readonly validating: boolean;
    readonly submitting: boolean;
    commit<K extends keyof M<T>>(type: K, config?: M<T>[K]): void;
    dispatch<K extends keyof A>(type: K, config?: A[K]): Promise<Response>;
    register(state: T, options?: ModuleOptions): void;
    unregister(): void;
}
export {};
